Index: Makefile
===================================================================
--- Makefile	(revision 3ab1d317831a6c1830bb648a1a8d63a41c92f651)
+++ Makefile	(revision a87e6ba665985301eedbe981a81110846aad8a9d)
@@ -10,5 +10,6 @@
 
 # Program variables
-objects = account.o bitlbee.o chat.o dcc.o help.o ipc.o irc.o irc_commands.o nick.o query.o root_commands.o set.o storage.o $(STORAGE_OBJS) user.o
+#objects = bitlbee.o chat.o dcc.o help.o ipc.o irc.o irc_commands.o nick.o query.o root_commands.o set.o storage.o $(STORAGE_OBJS)
+objects = bitlbee.o dcc.o help.o ipc.o irc.o irc_im.o irc_channel.o irc_commands.o irc_send.o irc_user.o nick.o root_commands.o set.o storage.o $(STORAGE_OBJS)
 headers = account.h bitlbee.h commands.h conf.h config.h help.h ipc.h irc.h log.h nick.h query.h set.h sock.h storage.h user.h lib/events.h lib/ftutil.h lib/http_client.h lib/ini.h lib/md5.h lib/misc.h lib/proxy.h lib/sha1.h lib/ssl_client.h lib/url.h protocols/ft.h protocols/nogaim.h
 subdirs = lib protocols
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision 3ab1d317831a6c1830bb648a1a8d63a41c92f651)
+++ bitlbee.h	(revision a87e6ba665985301eedbe981a81110846aad8a9d)
@@ -124,4 +124,5 @@
 #define CONF_FILE_DEF ETCDIR "bitlbee.conf"
 
+#include "bee.h"
 #include "irc.h"
 #include "storage.h"
@@ -158,5 +159,5 @@
 gboolean bitlbee_io_current_client_write( gpointer data, gint source, b_input_condition cond );
 
-void root_command_string( irc_t *irc, user_t *u, char *command, int flags );
+void root_command_string( irc_t *irc, char *command );
 void root_command( irc_t *irc, char *command[] );
 gboolean bitlbee_shutdown( gpointer data, gint fd, b_input_condition cond );
Index: conf.c
===================================================================
--- conf.c	(revision 3ab1d317831a6c1830bb648a1a8d63a41c92f651)
+++ conf.c	(revision a87e6ba665985301eedbe981a81110846aad8a9d)
@@ -369,5 +369,5 @@
 		if( g_strcasecmp( ini->section, "defaults" ) == 0 )
 		{
-			set_t *s = set_find( &irc->set, ini->key );
+			set_t *s = set_find( &irc->b->set, ini->key );
 			
 			if( s )
Index: dcc.c
===================================================================
--- dcc.c	(revision 3ab1d317831a6c1830bb648a1a8d63a41c92f651)
+++ dcc.c	(revision a87e6ba665985301eedbe981a81110846aad8a9d)
@@ -61,9 +61,8 @@
 unsigned int receivedchunks=0, receiveddata=0;
 
-static void dcc_finish( file_transfer_t *file );
-static void dcc_close( file_transfer_t *file );
+void dcc_finish( file_transfer_t *file );
+void dcc_close( file_transfer_t *file );
 gboolean dccs_send_proto( gpointer data, gint fd, b_input_condition cond );
-int dccs_send_request( struct dcc_file_transfer *df, char *user_nick, struct sockaddr_storage *saddr );
-gboolean dccs_recv_start( file_transfer_t *ft );
+int dccs_send_request( struct dcc_file_transfer *df, irc_user_t *iu, struct sockaddr_storage *saddr );
 gboolean dccs_recv_proto( gpointer data, gint fd, b_input_condition cond);
 gboolean dccs_recv_write_request( file_transfer_t *ft );
@@ -71,43 +70,5 @@
 gboolean dcc_abort( dcc_file_transfer_t *df, char *reason, ... );
 
-/* As defined in ft.h */
-file_transfer_t *imcb_file_send_start( struct im_connection *ic, char *handle, char *file_name, size_t file_size )
-{
-	user_t *u = user_findhandle( ic, handle );
-	/* one could handle this more intelligent like imcb_buddy_msg.
-	 * can't call it directly though cause it does some wrapping.
-	 * Maybe give imcb_buddy_msg a parameter NO_WRAPPING? */
-	if (!u) return NULL;
-
-	return dccs_send_start( ic, u->nick, file_name, file_size );
-};
-
-/* As defined in ft.h */
-void imcb_file_canceled( file_transfer_t *file, char *reason )
-{
-	if( file->canceled )
-		file->canceled( file, reason );
-
-	dcc_close( file );
-}
-
-/* As defined in ft.h */
-gboolean imcb_file_recv_start( file_transfer_t *ft )
-{
-	return dccs_recv_start( ft );
-}
-
-/* As defined in ft.h */
-void imcb_file_finished( file_transfer_t *file )
-{
-	dcc_file_transfer_t *df = file->priv;
-
-	if( file->bytes_transferred >= file->file_size )
-		dcc_finish( file );
-	else
-		df->proto_finished = TRUE;
-}
-
-dcc_file_transfer_t *dcc_alloc_transfer( char *file_name, size_t file_size, struct im_connection *ic )
+dcc_file_transfer_t *dcc_alloc_transfer( const char *file_name, size_t file_size, struct im_connection *ic )
 {
 	file_transfer_t *file = g_new0( file_transfer_t, 1 );
@@ -124,8 +85,9 @@
 
 /* This is where the sending magic starts... */
-file_transfer_t *dccs_send_start( struct im_connection *ic, char *user_nick, char *file_name, size_t file_size )
+file_transfer_t *dccs_send_start( struct im_connection *ic, irc_user_t *iu, const char *file_name, size_t file_size )
 {
 	file_transfer_t *file;
 	dcc_file_transfer_t *df;
+	irc_t *irc = (irc_t *) ic->bee->ui_data;
 	struct sockaddr_storage saddr;
 	char *errmsg;
@@ -150,5 +112,5 @@
 	file->status = FT_STATUS_LISTENING;
 
-	if( !dccs_send_request( df, user_nick, &saddr ) )
+	if( !dccs_send_request( df, iu, &saddr ) )
 		return NULL;
 
@@ -156,5 +118,5 @@
 	df->watch_in = b_input_add( df->fd, GAIM_INPUT_READ, dccs_send_proto, df );
 
-	df->ic->irc->file_transfers = g_slist_prepend( df->ic->irc->file_transfers, file );
+	irc->file_transfers = g_slist_prepend( irc->file_transfers, file );
 
 	df->progress_timeout = b_timeout_add( DCC_MAX_STALL * 1000, dcc_progress, df );
@@ -163,5 +125,5 @@
 	              "Accept the file transfer if you'd like the file. If you don't, "
 	              "issue the 'transfers reject' command.",
-	              user_nick, file_name, file_size / 1024 );
+	              iu->nick, file_name, file_size / 1024 );
 
 	return file;
@@ -216,5 +178,5 @@
 
 /* Creates the "DCC SEND" line and sends it to the server */
-int dccs_send_request( struct dcc_file_transfer *df, char *user_nick, struct sockaddr_storage *saddr )
+int dccs_send_request( struct dcc_file_transfer *df, irc_user_t *iu, struct sockaddr_storage *saddr )
 {
 	char ipaddr[INET6_ADDRSTRLEN]; 
@@ -250,6 +212,5 @@
 				df->ft->file_name, ipaddr, port, df->ft->file_size );
 	
-	if ( !irc_msgfrom( df->ic->irc, user_nick, cmd ) )
-		return dcc_abort( df, "Couldn't send `DCC SEND' message to %s.", user_nick );
+	irc_send_msg_raw( iu, "PRIVMSG", iu->irc->user->nick, cmd );
 
 	g_free( cmd );
@@ -496,7 +457,8 @@
  * Cleans up after a transfer.
  */
-static void dcc_close( file_transfer_t *file )
+void dcc_close( file_transfer_t *file )
 {
 	dcc_file_transfer_t *df = file->priv;
+	irc_t *irc = (irc_t *) df->ic->bee->ui_data;
 
 	if( file->free )
@@ -514,5 +476,5 @@
 		b_event_remove( df->progress_timeout );
 	
-	df->ic->irc->file_transfers = g_slist_remove( df->ic->irc->file_transfers, file );
+	irc->file_transfers = g_slist_remove( irc->file_transfers, file );
 	
 	g_free( df );
@@ -544,4 +506,5 @@
 file_transfer_t *dcc_request( struct im_connection *ic, char *line )
 {
+	irc_t *irc = (irc_t *) ic->bee->ui_data;
 	char *pattern = "SEND"
 		" (([^\"][^ ]*)|\"(([^\"]|\\\")*)\")"
@@ -627,5 +590,5 @@
 		g_free( input );
 
-		df->ic->irc->file_transfers = g_slist_prepend( df->ic->irc->file_transfers, ft );
+		irc->file_transfers = g_slist_prepend( irc->file_transfers, ft );
 
 		return ft;
Index: dcc.h
===================================================================
--- dcc.h	(revision 3ab1d317831a6c1830bb648a1a8d63a41c92f651)
+++ dcc.h	(revision a87e6ba665985301eedbe981a81110846aad8a9d)
@@ -95,10 +95,11 @@
 } dcc_file_transfer_t;
 
-file_transfer_t *dccs_send_start( struct im_connection *ic, char *user_nick, char *file_name, size_t file_size );
+file_transfer_t *dccs_send_start( struct im_connection *ic, irc_user_t *iu, const char *file_name, size_t file_size );
+void dcc_canceled( file_transfer_t *file, char *reason );
+gboolean dccs_send_write( file_transfer_t *file, char *data, unsigned int data_size );
+file_transfer_t *dcc_request( struct im_connection *ic, char *line );
+void dcc_finish( file_transfer_t *file );
+void dcc_close( file_transfer_t *file );
+gboolean dccs_recv_start( file_transfer_t *ft );
 
-void dcc_canceled( file_transfer_t *file, char *reason );
-
-gboolean dccs_send_write( file_transfer_t *file, char *data, unsigned int data_size );
-
-file_transfer_t *dcc_request( struct im_connection *ic, char *line );
 #endif
Index: ipc.c
===================================================================
--- ipc.c	(revision 3ab1d317831a6c1830bb648a1a8d63a41c92f651)
+++ ipc.c	(revision a87e6ba665985301eedbe981a81110846aad8a9d)
@@ -138,5 +138,5 @@
 	
 	if( strchr( irc->umode, 'w' ) )
-		irc_write( irc, ":%s WALLOPS :%s", irc->myhost, cmd[1] );
+		irc_write( irc, ":%s WALLOPS :%s", irc->root->host, cmd[1] );
 }
 
@@ -147,5 +147,5 @@
 	
 	if( strchr( irc->umode, 's' ) )
-		irc_write( irc, ":%s NOTICE %s :%s", irc->myhost, irc->nick, cmd[1] );
+		irc_write( irc, ":%s NOTICE %s :%s", irc->root->host, irc->user->nick, cmd[1] );
 }
 
@@ -156,5 +156,5 @@
 	
 	if( strchr( irc->umode, 'o' ) )
-		irc_write( irc, ":%s NOTICE %s :*** OperMsg *** %s", irc->myhost, irc->nick, cmd[1] );
+		irc_write( irc, ":%s NOTICE %s :*** OperMsg *** %s", irc->root->host, irc->user->nick, cmd[1] );
 }
 
@@ -176,8 +176,8 @@
 		return;
 	
-	if( nick_cmp( cmd[1], irc->nick ) != 0 )
+	if( nick_cmp( cmd[1], irc->user->nick ) != 0 )
 		return;		/* It's not for us. */
 	
-	irc_write( irc, ":%s!%s@%s KILL %s :%s", irc->mynick, irc->mynick, irc->myhost, irc->nick, cmd[2] );
+	irc_write( irc, ":%s!%s@%s KILL %s :%s", irc->root->nick, irc->root->nick, irc->root->host, irc->user->nick, cmd[2] );
 	irc_abort( irc, 0, "Killed by operator: %s", cmd[2] );
 }
@@ -188,5 +188,5 @@
 		ipc_to_master_str( "HELLO\r\n" );
 	else
-		ipc_to_master_str( "HELLO %s %s :%s\r\n", irc->host, irc->nick, irc->realname );
+		ipc_to_master_str( "HELLO %s %s :%s\r\n", irc->user->host, irc->user->nick, irc->user->fullname );
 }
 
